#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
	cv::Mat binary = cv::imread("../slovakia-binary.png",cv::IMREAD_GRAYSCALE);
	if (binary.empty()) return -1;
	
    cv::namedWindow("Morphology", 0);
    int mode = 0;
    int last_mode = -1;
    cv::createTrackbar("mode", "Morphology", &mode, 3, NULL);
    int ksize = 0;
    int last_ksize = ksize;
    cv::createTrackbar("ksize", "Morphology", &ksize, 25, NULL);
    
    cv::Mat binary2;

    for (;;) {
        if (mode != last_mode || ksize != last_ksize) {
            last_mode = mode;
            last_ksize = ksize;

            switch (mode) {
            case 0:
                std::cout << "erosion" << std::endl;
                cv::erode(binary,binary2,cv::getStructuringElement(cv::MORPH_RECT,cv::Size(2*ksize+1,2*ksize+1)));
                break;
            case 1:
                std::cout << "dilation" << std::endl;
                cv::dilate(binary,binary2,cv::getStructuringElement(cv::MORPH_RECT,cv::Size(2*ksize+1,2*ksize+1)));
                break;
            case 2:
                std::cout << "opening" << std::endl;
                cv::morphologyEx(binary,binary2,cv::MORPH_OPEN,cv::getStructuringElement(cv::MORPH_RECT,cv::Size(2*ksize+1,2*ksize+1)));
                break;
            case 3:
                std::cout << "closing" << std::endl;
                cv::morphologyEx(binary,binary2,cv::MORPH_CLOSE,cv::getStructuringElement(cv::MORPH_RECT,cv::Size(2*ksize+1,2*ksize+1)));
                break;
            }
            cv::imshow("Morphology",binary2);
        }

		int key = cv::waitKey(10);
		if (key == 27) break;
        else if (key == 's') cv::imwrite("morphology.png",binary2);
	}
	return 0;
}
