#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
	cv::Mat binary = cv::imread("../slovakia-opened.png",cv::IMREAD_GRAYSCALE);
	if (binary.empty()) return -1;

    cv::imshow("contoures",binary);
    cv::waitKey(0);
    
    std::vector<std::vector<cv::Point> > contours;
    std::vector<cv::Vec4i> hierarchy;
    cv::findContours(binary,contours,hierarchy,cv::RETR_TREE,cv::CHAIN_APPROX_SIMPLE);
    
    cv::Mat image(binary.size(),CV_8UC3,cv::Scalar(0,0,0));
    cv::RNG rng;
    for (int i=0; i<static_cast<int>(contours.size()); i++) {
        cv::Scalar color(rng.uniform(0,255),rng.uniform(0,255),rng.uniform(0,255));
        cv::drawContours(image,contours,i,color,1);
    }

    cv::imshow("contoures",image);
    cv::waitKey(0);

	cv::destroyAllWindows();
	return 0;
}
