#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
	cv::Mat binary = cv::imread("../slovakia-closed.png",cv::IMREAD_GRAYSCALE);
	if (binary.empty()) return -1;

    cv::imshow("components",binary);
    cv::waitKey(0);
    
    cv::Mat labels(binary.size(),CV_32SC1);
    int count = cv::connectedComponents(binary,labels);
    
    cv::RNG rng;
    std::vector<cv::Vec3b> colors;
    for (int i=0; i<count; i++) {
        cv::Vec3b color(rng.uniform(0,255),rng.uniform(0,255),rng.uniform(0,255));
        colors.push_back(color);
    }
    
    cv::Mat image(binary.size(),CV_8UC3,cv::Scalar(0,0,0));
    for (int y=0; y<image.rows; y++) {
        cv::Vec3b *pixel = image.ptr<cv::Vec3b>(y); 
        int *label = labels.ptr<int>(y); 
        for (int x=0; x<image.cols; x++) 
            pixel[x] = colors[label[x]];
    }

    cv::imshow("components",image);
    cv::waitKey(0);

	cv::destroyAllWindows();
	return 0;
}
